<template>
  <q-page class="row q-pa-md">
    <div class="column col-3 q-pa-md justify-start">
      <span class="nunito text-h4 text-center col-1">Experiments</span>
      <q-input v-model="search_bar.model.value" hint="Search experiment" class="search-bar col-1">
        <template v-slot:append>
          <q-icon name="search" />
        </template>
      </q-input>
      <q-scroll-area
        :thumb-style="thumbStyle"
        :content-style="contentStyle"
        :content-active-style="contentActiveStyle"
        :bar-style="barStyle"
        class="col q-mt-lg"
      >
        <q-list bordered separator>
          <q-item
            :active="experiment.path === selected_experiment.path"
            clickable
            v-ripple
            v-for="(experiment, index) in shown_experiments"
            :key="'experiment' + index"
            @click="scoutTasks(experiment)"
          >
            <q-item-section avatar>
              <q-icon name="folder" color="primary" text-color="white" />
            </q-item-section>
            <q-item-section>
              <q-item-label>{{ experiment.name }}</q-item-label>
              <q-item-label caption>{{ experiment.logs.length }} logs</q-item-label>
            </q-item-section>
          </q-item>
        </q-list>
      </q-scroll-area>
    </div>
    <div class="column col q-pa-md">
      <div class="col-1"></div>
      <div class="col-6" id="plot" style="width: 100%"></div>
      <div class="col-1 row items-center justify-center" style="width: 100%">
        <line-button-vue
          v-for="(header, index) in headers.slice(1)"
          :key="'header-toggle' + index"
          flat
          :color="colors[index]"
          :label="header"
          :visible="visibility_table[index]"
          @toggled="toggleLine(index)"
          class="col-1"
        />
      </div>
      <div class="col row">
        <div class="col-3 column">
          <span class="text-center nunito text-h6 col-1">Logs</span>
          <div class="column col q-mt-md">
            <q-scroll-area
              v-if="selected_experiment.path !== ''"
              :thumb-style="thumbStyle"
              :content-style="contentStyle"
              :content-active-style="contentActiveStyle"
              :bar-style="barStyle"
              class="col"
            >
              <q-list bordered separator style="height: 100%">
                <q-item
                  clickable
                  v-ripple
                  v-for="(task, index) in tasks"
                  :key="'task' + index"
                  @click="read_csv(task)"
                  :active="task === selected_task"
                >
                  <q-item-section avatar>
                    <q-icon name="mdi-file-delimited-outline" color="primary" text-color="white" />
                  </q-item-section>
                  <q-item-section>
                    <q-item-label>{{ task }}</q-item-label>
                  </q-item-section>
                </q-item>
              </q-list>
            </q-scroll-area>
            <div v-else class="col-3">
              <q-icon name="mdi-arrow-left-bold" size="md" />Select an experiment from the Experiment menu
            </div>
          </div>
        </div>
        <div class="column col">
          <div class="row col-2">
            <span class="col text-center">{{ selected_experiment.name }} - {{ selected_task }}</span>
          </div>
          <div class="row">
            <q-btn class="col-2" icon="mdi-application-export" label="Export" flat />
          </div>
        </div>
        <q-inner-loading :showing="show_loading">
          <q-spinner-cube color="orange" size="6em" />
          <span class="text-orange" style="font-size: 1.2em">Loading CSV file...</span>
        </q-inner-loading>
      </div>
    </div>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref, Ref, computed } from 'vue';
import { ExperimentDir } from 'src/models/logs';
import Dygraph from 'dygraphs';
import LineButtonVue from 'components/plot/LineButton.vue';
import { scrollBarStyle } from 'src/components/task/utils';

export default defineComponent({
  components: {
    LineButtonVue,
  },
  setup() {
    const time_index_absolute = ref(0);
    const data: Ref<Array<Array<number>>> = ref([]);
    const headers: Ref<Array<string>> = ref([]);
    const counter = ref(0);
    const colors = ['#ca6037', '#717ccd', '#75ab3d', '#bd5db0', '#54a77b', '#cc566c', '#b49242'];
    const visibility_table: Ref<Array<boolean>> = ref([]);
    let plot: Dygraph | null = null;
    const show_loading = ref(false);
    const initPlot = () => {
      plot = new Dygraph('plot', [], {
        labels: [],
        colors: colors,
        strokeWidth: 1.0,
      });
      // show the plot
      setTimeout(() => {
        plot?.resize();
      }, 100);
    };

    const search_bar = {
      model: ref(''),
      filter: (input: string) => input.toLowerCase().includes(search_bar.model.value.toLowerCase()),
    };

    const experiments = ref(new Array<ExperimentDir>());
    const shown_experiments = computed(() =>
      experiments.value.filter((dir: ExperimentDir) => search_bar.filter(dir.name))
    );
    const selected_experiment: Ref<ExperimentDir> = ref({
      name: '',
      path: '',
      logs: [],
    });
    const tasks = ref(new Array<string>());
    const selected_task = ref('');

    const scoutTasks = (experiment: ExperimentDir) => {
      void window.library.list_tasks(experiment.path).then((task_list) => (tasks.value = task_list));
      selected_experiment.value = experiment;
    };

    const read_csv = (csv_name: string) => {
      show_loading.value = true;
      void window.library
        .read_csv(selected_experiment.value.path + csv_name)
        .then((data) => {
          updateLabels(data.headers);
          updateData(data.data);
          selected_task.value = csv_name;
        })
        .finally(() => (show_loading.value = false));
    };

    const updateLabels = (header: Array<string>) => {
      // note: time should be the first element
      const time_index = header.indexOf('t');
      if (time_index > -1) {
        const time_string = header.splice(time_index, 1);
        header = time_string.concat(header);
        time_index_absolute.value = time_index;
      } else {
        // A counter is used instead of the time value for the x axis
        header = ['Time'].concat(header);
        time_index_absolute.value = 0;
      }
      headers.value = header;
      visibility_table.value = plot ? plot.visibility() : Array<boolean>(header.length - 1);
      counter.value = 0;
    };

    const updateData = (values: Array<Array<number>>) => {
      const time_index = time_index_absolute.value;
      if (time_index > -1) {
        const time_value = values.splice(time_index, 1);
        values = time_value.concat(values);
      }
      values = values.map((row) => {
        const time = row.splice(time_index, 1);
        return time.concat(row);
      });
      plot?.updateOptions({
        labels: headers.value,
        file: values,
      });
    };

    const toggleLine = (index: number) => {
      visibility_table.value[index] = !visibility_table.value[index];
      plot?.setVisibility(index, visibility_table.value[index]);
    };

    onMounted(() => {
      initPlot();
      void window.library.list_experiments().then((data) => {
        experiments.value = data;
      });
    });

    return {
      experiments,
      shown_experiments,
      selected_experiment,
      tasks,
      scoutTasks,
      read_csv,
      visibility_table,
      headers,
      toggleLine,
      colors,
      search_bar,
      ...scrollBarStyle,
      selected_task,
      show_loading,
    };
  },
});
</script>

<style lang="sass">
.search-bar
  width: 66%
  margin-left: auto
  margin-right: auto

.selected-dir
  color: white
  background: #F2C037
</style>